﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace FolderPictureBrowser
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        List<string> Extensions = new List<string>();

        private void Form1_Load(object sender, EventArgs e)
        {
            Extensions.Add("*.bmp");
            Extensions.Add("*.jpg");
            Extensions.Add("*.jpeg");
            Extensions.Add("*.png");
            Extensions.Add("*.gif");
            Extensions.Add("*.tif");
            Extensions.Add("*.tiff");
        }

        private void LoadButton_Click(object sender, EventArgs e)
        {
            string Path = PathTextBox.Text;
            while (Path.EndsWith("\\"))
            {
                Path = Path.Substring(0, Path.Length - 1); //Prečistíme cestu aby nekončila znakom \
            }
            if (Directory.Exists(Path)) //Ak cesta existuje
            {
                ImagesListView.Items.Clear();
                imageList1.Images.Clear(); //Vyčistime ListView aj ImageList
                foreach (string Extension in Extensions)
                { //Pre každú príponu, ktorú sme pridali,
                    foreach (string File in Directory.GetFiles(PathTextBox.Text, Extension, (RecursiveCheckBox.Checked)? SearchOption.AllDirectories : SearchOption.TopDirectoryOnly))
                    {
                        //Prehladamé všetky priečinky.
                        //Kód (RecursiveCheckBox.Checked)? SearchOption.AllDirectories : SearchOption.TopDirectoryOnly)
                        //slúži na aktivovanie rekurzie podľka zaškrtnutia CheckBoxu.

                        ListViewItem item = new ListViewItem(File.Substring(Path.Length + 1));
                        item.ImageIndex = imageList1.Images.Count;

                        //Vytvoríme nový ListView, ktorému nastavíme text. ktorý vyjadruje relatívne meno súboru.
                        //Priradíme mu Index obrázka, ktorý je aktuálna pozícia v ImageListe

                        Text = "ImageViewer - " + File;
                        //Pre informáciu vypíšeme, ktorý súbor momentálne skúmame

                        Image img = Image.FromFile(File);
                        //Zo súboru prečítame Image

                        Image thumb = img.GetThumbnailImage(64, 64, () => false, IntPtr.Zero);
                        //Získame jeho Thumbnail (zmenšeninu)

                        img.Dispose();
                        //A pôvodný uvoľníme z pamäte.

                        imageList1.Images.Add(thumb);
                        //Na záver ho pridáme do imagelistu

                        ImagesListView.Items.Add(item);
                        //A item pridáme do ListViewu.
                    }
                }
                Text = "ImageViewer";
                //Môžeme obnoviť Text formu.
            }
        }

        private void BrowseButton_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog dialog = new FolderBrowserDialog();
            if (dialog.ShowDialog() == DialogResult.OK) //Ak je výsledok dialógu na výber priečinku OK
            {
                PathTextBox.Text = dialog.SelectedPath; //Dá do TextBoxu cestu.
            }
        }
    }
}
